	SUBROUTINE DSPOTPAR(IGPTB,MY,IPAN,IQPNT)
****************************************************************
*  Subroutine calculates change in the potential parameters.   *
****************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,NHSORT(NSORTMAX),IS(NPAT),NRAD(NSORTMAX),LR(NSORTMAX)
     &   ,NODES(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,MNY  (0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &   ,NKAP(NPANMAX)
	COMPLEX*16 HAN(3,0:LMAXT),BES(3,0:LMAXT),DFPMN(0:LMAXT)
     &   ,EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &   ,DPOT(0:NRADMAX,LMMAXV,NPAT,NSPINMAX),DVT(0:NRADMAX)
     &   ,DELAAH(0:LMAXT,NPAT,NKAPMAX,2,NPANMAX,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELBBH(0:LMAXT,NPAT,NKAPMAX,2,NPANMAX,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELAAJ(0:LMAXT,NPAT,NKAPMAX,2,NPANMAX,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELBBJ(0:LMAXT,NPAT,NKAPMAX,2,NPANMAX,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELENY(0:LMAXT,NPAT,NKAPMAX,NPANMAX,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELDNY(0:LMAXT,NPAT,NKAPMAX,NPANMAX,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELTNY(0:LMAXT,NPAT,NKAPMAX,NPANMAX,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELFF  (NKAPMAX,NKAPMAX,0:LMAXT,NPAT,NSPINMAX)
     &   ,DELFFP (NKAPMAX,NKAPMAX,0:LMAXT,NPAT,NSPINMAX)
     &   ,DELFPF (NKAPMAX,NKAPMAX,0:LMAXT,NPAT,NSPINMAX)
     &   ,DELFPFP(NKAPMAX,NKAPMAX,0:LMAXT,NPAT,NSPINMAX)
     &   ,DFI S(0:LMAXT,NKAPMAX),DFID S(0:LMAXT,NKAPMAX)
     &   ,DFIPS(0:LMAXT,NKAPMAX),DFIDPS(0:LMAXT,NKAPMAX)
     &   ,DELWFF,DELWFFP,DELWFPF,DELWFPFP,DE1
	DIMENSION DNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,ENY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,TNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,AFI S(0:LMAXT,NKAPMAX),AFID S(0:LMAXT,NKAPMAX)
     &   ,AFIPS(0:LMAXT,NKAPMAX),AFIDPS(0:LMAXT,NKAPMAX)
     &   ,FF(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NSPINMAX)
     &   ,FFP(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NSPINMAX)
     &   ,FPF(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NSPINMAX)
     &   ,FPFP(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NSPINMAX)
     &   ,R(0:NRADMAX,NSORTMAX),DR(0:NRADMAX,NSORTMAX)
     &   ,VSPH(0:NRADMAX,NSORTMAX,NSPINMAX),FPMN(0:LMAXT)
     &   ,DNYP(0:LMAXT,NKAPMAX),H(NSORTMAX),SMT(NSORTMAX)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	CHARACTER TXTEL(NSORTMAX)*10
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM        !!! from init
	COMMON /POTCOM/ SWZ,SMT,VSPH                         !!! from vfull
	COMMON /INPPAR/ TNY,ENY,DNY,NODES,MNY                !!! from init
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                    !!! from init
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                !!! from init
	COMMON /POTPAR/ FF,FFP,FPF,FPFP                      !!! from potpar
	COMMON /DINPPAR/DELTNY,DELENY,DELDNY                 !!! from init
	COMMON /DPOTPAR/DELFF,DELFFP,DELFPF,DELFPFP          !!! from dpotpar
	COMMON /DLMTPAR/DELAAH,DELBBH,DELAAJ,DELBBJ          !!! from dpotpar
	COMMON /DELPOT/ DPOT                                 !!! from delpot
	COMMON /RELATIV/LR                                   !!! from init
	COMMON /RADMESH/NRAD,H,R,DR                          !!! from radmsh
	COMMON /SPIN/   NSPIN                                !!! from init
	COMMON /DLFCOM/ NDLF,LDLF,IDLF                       !!! from init
	COMMON /UNIT/   IUN                                  !!! from init
	COMMON /TXTEL/  TXTEL                                !!! from init
	DATA PI/3.141592653589793D0/
	DO 1000 ISPIN=1,NSPIN                             !!! over spins
	DO IATOM=1,NATOM                                  !!! over isort
	ISORT=IS(IATOM)
	DO IKAP=1,NKAP(IPAN)                              !!! over ikap
	CALL BESSEL(SMT(ISORT),EKAP(IKAP,IPAN),SMT(ISORT),BES,
     &  ILST(ISORT))
	CALL HANKEL(SMT(ISORT),EKAP(IKAP,IPAN),SMT(ISORT),HAN,
     &  ILST(ISORT))
C  SOLVE LINEARIZED SCHROEDINGER'S EQUATION FOR SET OF ENY
	DO IRAD=0,NRAD(ISORT)
	IF(LDLF.EQ.2)DVT(IRAD)=DPOT(IRAD,1,IATOM,ISPIN)
	IF(LDLF.EQ.1)DVT(IRAD)=(0.D0,0.D0)
	ENDDO
	CALL DRUNGE(ENY(0,ISORT,IKAP,IPAN,ISPIN),
     &  DELENY(0,IATOM,IKAP,IPAN,ISPIN,IGPTB,MY),
     &  AFIS(0,IKAP),AFIPS(0,IKAP),AFIDS(0,IKAP),
     &  AFIDPS(0,IKAP),FPMN,DFIS(0,IKAP),DFIPS(0,IKAP),
     &  DFIDS(0,IKAP),DFIDPS(0,IKAP),DFPMN,SMT(ISORT),
     &  VSPH(0,ISORT,ISPIN),DVT(0),ILST(ISORT),
     &  NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),LR(ISORT))
	DO L=0,ILST(ISORT)                               !!! over l
        AFIDPS(L,IKAP)=AFIPS(L,IKAP)/AFIS(L,IKAP)*(AFIDS(L,IKAP)-
     &  1.D0/(SMT(ISORT)*SMT(ISORT)*AFIPS(L,IKAP)))
C  SET CHANGE IN MAIN POTENTIAL PARAMETERS OF THE FP-LMTO METHOD
	DELDNY(L,IATOM,IKAP,IPAN,ISPIN,IGPTB,MY)=
     &  SMT(ISORT)/AFIS(L,IKAP)*(
     &  DFIDS(L,IKAP)-AFIDS(L,IKAP)*DFIS(L,IKAP)/AFIS(L,IKAP))
	DELAAH(L,IATOM,IKAP,1,IPAN,ISPIN,IGPTB,MY)=+
     &  SMT(ISORT)*SMT(ISORT)*(
     &  DFIPS(L,IKAP)*HAN(2,L)-DFIDPS(L,IKAP)*HAN(1,L))      !!! +W{d-phidot,H}
	DELAAH(L,IATOM,IKAP,2,IPAN,ISPIN,IGPTB,MY)=+
     &  SMT(ISORT)*SMT(ISORT)*(
     &  DFIPS(L,IKAP)*CONJG(HAN(2,L))-DFIDPS(L,IKAP)*CONJG(HAN(1,L)))
	DELAAJ(L,IATOM,IKAP,1,IPAN,ISPIN,IGPTB,MY)=+
     &  SMT(ISORT)*SMT(ISORT)*(
     &  DFIPS(L,IKAP)*BES(2,L)-DFIDPS(L,IKAP)*BES(1,L))      !!! +W{d-phidot,J}
	DELAAJ(L,IATOM,IKAP,2,IPAN,ISPIN,IGPTB,MY)=+
     &  SMT(ISORT)*SMT(ISORT)*(
     &  DFIPS(L,IKAP)*CONJG(BES(2,L))-DFIDPS(L,IKAP)*CONJG(BES(1,L)))
	DELBBH(L,IATOM,IKAP,1,IPAN,ISPIN,IGPTB,MY)=-
     &  SMT(ISORT)*SMT(ISORT)*(
     &  DFIS(L,IKAP)*HAN(2,L)-DFIDS(L,IKAP)*HAN(1,L))        !!! -W{d-phi,H}
	DELBBH(L,IATOM,IKAP,2,IPAN,ISPIN,IGPTB,MY)=-
     &  SMT(ISORT)*SMT(ISORT)*(
     &  DFIS(L,IKAP)*CONJG(HAN(2,L))-DFIDS(L,IKAP)*CONJG(HAN(1,L)))
	DELBBJ(L,IATOM,IKAP,1,IPAN,ISPIN,IGPTB,MY)=-
     &  SMT(ISORT)*SMT(ISORT)*(
     &  DFIS(L,IKAP)*BES(2,L)-DFIDS(L,IKAP)*BES(1,L))        !!! -W{d-phi,J}
	DELBBJ(L,IATOM,IKAP,2,IPAN,ISPIN,IGPTB,MY)=-
     &  SMT(ISORT)*SMT(ISORT)*(
     &  DFIS(L,IKAP)*CONJG(BES(2,L))-DFIDS(L,IKAP)*CONJG(BES(1,L)))
	DNYP(L,IKAP)=DNY(L,ISORT,IKAP,IPAN,ISPIN)-1.D0/(SMT(ISORT)*
     &  AFIS(L,IKAP)*AFIPS(L,IKAP))
C  SET INTEGRALS BETWEEN CHANGE IN RADIAL WAVE FUNCTIONS
C  DIAGONAL ELEMENTS:
	DELFF  (IKAP,IKAP,L,IATOM,ISPIN)=0.D0
	DELFFP (IKAP,IKAP,L,IATOM,ISPIN)=0.D0
	DELFPF (IKAP,IKAP,L,IATOM,ISPIN)=0.D0
	DELFPFP(IKAP,IKAP,L,IATOM,ISPIN)=DFPMN(L)
C  OFF DIAGONAL ELEMENTS:
	DO JKAP=1,IKAP-1                                     !!! over jkap
C  IF ENY'S COINSIDE
	IF(ABS(ENY(L,ISORT,IKAP,IPAN,ISPIN)-ENY(L,ISORT,JKAP,IPAN,ISPIN))
     &  .LE.1.D-05)THEN
	DE1=DELENY(L,IATOM,IKAP,IPAN,ISPIN,IGPTB,MY)-
     &  DELENY(L,IATOM,JKAP,IPAN,ISPIN,IGPTB,MY)
	DELFF  (IKAP,JKAP,L,IATOM,ISPIN)=0.D0
	DELFFP (IKAP,JKAP,L,IATOM,ISPIN)=+DE1*FPMN(L)
	DELFPF (IKAP,JKAP,L,IATOM,ISPIN)=-DE1*FPMN(L)
	DELFPFP(IKAP,JKAP,L,IATOM,ISPIN)=DFPMN(L)
C  IF ENY'S DIFFER
	ELSE
C  FOR PHI-PHIDOTS
	E1=1.D0/(ENY(L,ISORT,IKAP,IPAN,ISPIN)-
     &  ENY(L,ISORT,JKAP,IPAN,ISPIN))
	WFF=SMT(ISORT)*AFIS(L,IKAP)*AFIS(L,JKAP)*
     &  (DNY(L,ISORT,JKAP,IPAN,ISPIN)-DNY(L,ISORT,IKAP,IPAN,ISPIN))
	WFFP=SMT(ISORT)*AFIS(L,IKAP)*AFIPS(L,JKAP)*
     &  (DNYP(L,JKAP)-DNY(L,ISORT,IKAP,IPAN,ISPIN))
	WFPF=SMT(ISORT)*AFIPS(L,IKAP)*AFIS(L,JKAP)*
     &  (DNY(L,ISORT,JKAP,IPAN,ISPIN)-DNYP(L,IKAP))
	WFPFP=SMT(ISORT)*AFIPS(L,IKAP)*AFIPS(L,JKAP)*
     &  (DNYP(L,JKAP)-DNYP(L,IKAP))
C  FOR PERTURBATIVE FUNCTIONS
	E1=1.D0/(ENY(L,ISORT,IKAP,IPAN,ISPIN)-
     &  ENY(L,ISORT,JKAP,IPAN,ISPIN))
	DE1=-(DELENY(L,IATOM,IKAP,IPAN,ISPIN,IGPTB,MY)-
     &  DELENY(L,IATOM,JKAP,IPAN,ISPIN,IGPTB,MY))*E1*E1
	DELWFF=SMT(ISORT)**2*(DFIS(L,IKAP)*AFIDS(L,JKAP)-
     &  DFIDS(L,IKAP)*AFIS(L,JKAP)+AFIS(L,IKAP)*DFIDS(L,JKAP)-
     &  AFIDS(L,IKAP)*DFIS(L,JKAP))
	DELWFFP=SMT(ISORT)**2*(DFIS(L,IKAP)*AFIDPS(L,JKAP)-
     &  DFIDS(L,IKAP)*AFIPS(L,JKAP)+AFIS(L,IKAP)*DFIDPS(L,JKAP)-
     &  AFIDS(L,IKAP)*DFIPS(L,JKAP))
	DELWFPF=SMT(ISORT)**2*(DFIPS(L,IKAP)*AFIDS(L,JKAP)-
     &  DFIDPS(L,IKAP)*AFIS(L,JKAP)+AFIPS(L,IKAP)*DFIDS(L,JKAP)-
     &  AFIDPS(L,IKAP)*DFIS(L,JKAP))
	DELWFPFP=SMT(ISORT)**2*(DFIPS(L,IKAP)*AFIDPS(L,JKAP)-
     &  DFIDPS(L,IKAP)*AFIPS(L,JKAP)+AFIPS(L,IKAP)*DFIDPS(L,JKAP)-
     &  AFIDPS(L,IKAP)*DFIPS(L,JKAP))
	DELFF  (IKAP,JKAP,L,IATOM,ISPIN)=E1*DELWFF+DE1*WFF
	DELFFP (IKAP,JKAP,L,IATOM,ISPIN)=E1*(DELWFFP+
     &  DELFF  (IKAP,JKAP,L,IATOM,ISPIN))+
     &  DE1*(WFFP+FF(IKAP,JKAP,L,ISORT,ISPIN))
	DELFPF (IKAP,JKAP,L,IATOM,ISPIN)=E1*(DELWFPF-
     &  DELFF  (IKAP,JKAP,L,IATOM,ISPIN))+
     &  DE1*(WFPF-FF(IKAP,JKAP,L,ISORT,ISPIN))
	DELFPFP(IKAP,JKAP,L,IATOM,ISPIN)=E1*(DELWFPFP+
     &  DELFPF (IKAP,JKAP,L,IATOM,ISPIN)-
     &  DELFFP (IKAP,JKAP,L,IATOM,ISPIN))+
     &  DE1*(WFPFP+FPF(IKAP,JKAP,L,ISORT,ISPIN)-
     &  FFP(IKAP,JKAP,L,ISORT,ISPIN))
	ENDIF
C  ACCOUNT FOR SYMMETRICITY
	DELFF  (JKAP,IKAP,L,IATOM,ISPIN)=DELFF  (IKAP,JKAP,L,IATOM,ISPIN)
	DELFFP (JKAP,IKAP,L,IATOM,ISPIN)=DELFPF (IKAP,JKAP,L,IATOM,ISPIN)
	DELFPF (JKAP,IKAP,L,IATOM,ISPIN)=DELFFP (IKAP,JKAP,L,IATOM,ISPIN)
	DELFPFP(JKAP,IKAP,L,IATOM,ISPIN)=DELFPFP(IKAP,JKAP,L,IATOM,ISPIN)
        ENDDO                                                   !!! over jkap
        ENDDO                                                   !!! over l
        ENDDO                                                   !!! over ikap
        ENDDO                                                   !!! over isort
1000	CONTINUE                                                !!! over spins
	END
