	SUBROUTINE MIXDRO(IQPNT,ITER,EXIT)
******************************************************
*  Admixture of the induced charge density in the    *
*  self-consistent cycle. (MT-sphere part)           *
******************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,ISTS(NSORTMAX,NPANMAX),NKAP(NPANMAX),NRAD(NSORTMAX)
     &   ,IS(NPAT),NHSORT(NSORTMAX),IATS(NPAT,NPANMAX)
     &   ,NQDIV(3),LBROY(0:NENVMAX,-1:2),IBROY(0:NENVMAX,-1:2)
     &   ,KSP(0:NENVMAX,-1:2),INDGCON(0:NENVMAX,0:NENVMAX)
     &   ,INDGPTB(0:NENVMAX),INGPTBR(NOPRMAX,0:NENVMAX)
     &   ,NITER(0:NENVMAX,-1:2),KEY(0:NENVMAX,-1:2)
	DIMENSION SMT(NSORTMAX),H(NSORTMAX),R(0:NRADMAX,NSORTMAX)
     &   ,DR(0:NRADMAX,NSORTMAX),WEIGHT(0:NRADMAX,NSORTMAX)
     &   ,RL(0:NRADMAX,0:LMAXV,NSORTMAX)
	DIMENSION QPNT(3),EPS(0:NENVMAX,-1:2),GPTB(3,0:NENVMAX)
     &   ,ADMIX1(0:NENVMAX,-1:2),ADMIN (0:NENVMAX,-1:2)
     &   ,ADMAX (0:NENVMAX,-1:2),ADMSPN(0:NENVMAX,-1:2)
     &   ,ASMIN (0:NENVMAX,-1:2),ASMAX (0:NENVMAX,-1:2)
     &   ,ADMOPT(0:NENVMAX,-1:2),ADSPIN(0:NENVMAX,-1:2)
     &   ,DPRATC(0:NENVMAX,-1:2),DPRATM(0:NENVMAX,-1:2)
     &   ,ADMIXB(0:NENVMAX,-1:2),ADMIXH(0:NENVMAX,-1:2)
        DIMENSION CONVDRO(0:NENVMAX,-1:2),CONVDMO(0:NENVMAX,-1:2)
     &   ,CONVDMG(-1:1,0:NENVMAX,-1:2)
        COMPLEX*16 
     &    DRHOOUT,DRHOINP,DRHONEW,DMAGOUT,DMAGINP,DMAGNEW
     &   ,WORK1(0:NRADMAX),WORK2(0:NRADMAX),WORK3(0:NRADMAX)
     &   ,DCHINP(LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DCHOUT(LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DMGINP(LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DMGOUT(LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
        COMPLEX*16
     &    DRHO(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
     &   ,DMAG(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
     &   ,TRHO(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
     &   ,TMAG(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
     &   ,DELDOCC(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELMOCC(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELDHUB(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELMHUB(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
	CHARACTER TXTEL(NSORTMAX)*10,POL(-1:2)*1
	LOGICAL EXIT
C Controls:
	COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE         !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM        !!! from init
        COMMON /PLZCOM/ NPLZ,LPLZ,IPLZ                       !!! from init
	COMMON /SPIN/   NSPIN                                !!! from init
C Inputs:
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                    !!! from init
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                !!! from init
	COMMON /MAGCOM/ ITERMAX,NITER,EPS,CONVDRO,CONVDMO,CONVDMG
	COMMON /POTCOM/ SWZ,SMT                              !!! from init
	COMMON /QMESH/  NQPNT,QPNT,NUMQ,NQDIV,KEYQ           !!! from init
        COMMON /PTBCOM/ NGSHL,NGPTB,GPTB,INDGPTB,INGPTBR,INDGCON!from plwptb
C Mixings:
        COMMON /MIXDRHO/ADMIX1,ADMIN,ADMAX,KEY,ADMOPT        !!! from mixdrho
        COMMON /MIXDMAG/ADMSPN,ASMIN,ASMAX,KSP,ADSPIN        !!! from mixdrho
        COMMON /MIXDBRD/LBROY,IBROY,ADMIXB,ADMIXH            !!! from mixdrob
        COMMON /INPDCH/ DCHINP,DPSINP,DMGINP,DMSINP          !!! from print3
     &                 ,DCHOUT,DPSOUT,DMGOUT,DMSOUT          !!! from print4
C Density:
        COMMON /DELRO/  DRHO,DMAG                            !!! from delro
        COMMON /DELPOT/ TRHO,TMAG                            !!! from delro
C Occupancies
        COMMON /DELOCC/ DELDOCC,DELMOCC                     !!! from drhohub
        COMMON /DELHUB/ DELDHUB,DELMHUB                     !!! from drhohub
C Rad.mesh:
	COMMON /RADMESH/NRAD,H,R,DR,WEIGHT,RL                !!! from radmsh
C Outputs:
        COMMON /UNIT/   IUN,IUT,IUR                          !!! from init
	COMMON /WORD/   NVAL                                 !!! from block
	COMMON /TXTEL/  TXTEL                                !!! from init
	DATA PI/3.141592653589793D0/,POL/'m','z','p','v'/
	EXIT=.FALSE.
        IF((MODE.EQ.4.OR.MODE.EQ.5).AND.ITER.GE.1)RETURN
C *** DO GLOBALLY OVER POLARIZATIONS 
	DO 2000 MY=-1,2                        !!! over polarizations
	DO 1000 IGPTB=0,NGPTB                  !!! over g-vectors
	IF(NITER(IGPTB,MY).EQ.0)GOTO1000
C ITER<1, NOTHING IS KNOWN AT THE MOMENT
	IF(ITER.LT.1.AND.MODE.EQ.1)THEN 
	CALL DROFILES(IGPTB,MY,IQPNT,32,'I')
	CALL DROFILES(IGPTB,MY,IQPNT,33,'I')
C ITER<1, EVERYTHING IS KNOWN
	ELSEIF(ITER.LT.1.AND.MODE.GT.1)THEN
	CALL DROFILES(IGPTB,MY,IQPNT,33,'I')
	CALL DROFILES(IGPTB,MY,IQPNT,32,'R')
	CALL DROFILES(IGPTB,MY,IQPNT,33,'W')
	ENDIF
C INITIALIZE OCCUPANCIES
        DO IATOM=1,NATOM                           !!! over atoms
        ISORT=IS(IATOM)
        DO ISPIN=1,NSPIN                           !!! over spins
        ITRAN=ISPIN
        DO L=0,ILSB(ISORT)
        DO M=-L,L
        LM=L*(L+1)+M+1
        DO K=-L,L                                 !!! over k
        IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1           !  (l,m k) packed
	IF(ITER.LT.1.AND.MODE.EQ.1)THEN
	DELDHUB(IU,IATOM,ISPIN,IGPTB,MY)=(0.D0,0.D0)
	DELMHUB(IU,IATOM,ITRAN,IGPTB,MY)=(0.D0,0.D0)
	ELSEIF(ITER.LT.1.AND.MODE.GT.1)THEN
	DELDHUB(IU,IATOM,ISPIN,IGPTB,MY)=
     &	DELDOCC(IU,IATOM,ISPIN,IGPTB,MY)
	DELMHUB(IU,IATOM,ITRAN,IGPTB,MY)=
     &	DELMOCC(IU,IATOM,ITRAN,IGPTB,MY)
	ENDIF
        ENDDO
        ENDDO
        ENDDO
        ENDDO                                      !!! over spins
        ENDDO                                      !!! over atoms
	IF(ITER.LT.1)GOTO1000
C CHARGE DENSITY DIFFERENCE BETWEEN TWO ITERATIONS
	CALL DROFILES(IGPTB,MY,IQPNT,32,'R')
        DO IATOM=1,NATOM
        ISORT=IS(IATOM)
        DO ISPIN=1,NSPIN
	ITRAN=ISPIN
        DO L=0,ILSV(ISORT)
        DO M=-L,L
        LM=L*(L+1)+M+1
        DO IRAD=0,NRAD(ISORT)
        TRHO(IRAD,LM,IATOM,ISPIN)=DRHO(IRAD,LM,IATOM,ISPIN)
        TMAG(IRAD,LM,IATOM,ITRAN)=DMAG(IRAD,LM,IATOM,ITRAN)
        ENDDO
        ENDDO
        ENDDO
        ENDDO
        ENDDO
	CALL DROFILES(IGPTB,MY,IQPNT,33,'R')
	CONVDRO(IGPTB,MY)=0.D0
	CONVDMO(IGPTB,MY)=0.D0
	CONVDMG(-1,IGPTB,MY)=0.D0
	CONVDMG( 0,IGPTB,MY)=0.D0
	CONVDMG(+1,IGPTB,MY)=0.D0
        DO IATOM=1,NATOM                                 !!! over atoms
        ISORT=IS(IATOM)
        DO L=0,ILSV(ISORT)                               !!! over l
	DO M=-L,L                                        !!! over m
	LM=L*(L+1)+M+1
	DO IRAD=0,NRAD(ISORT)
C DENSITY CONVERGENCY
        DRHOOUT=(DRHO(IRAD,LM,IATOM,1)+DRHO(IRAD,LM,IATOM,NSPIN))/
     &  2.D0*DBLE(NSPIN)
        DRHOINP=(TRHO(IRAD,LM,IATOM,1)+TRHO(IRAD,LM,IATOM,NSPIN))/
     &  2.D0*DBLE(NSPIN)
        WORK1(IRAD)=DCONJG(DRHOOUT-DRHOINP)*(DRHOOUT-DRHOINP)*
     &  WEIGHT(IRAD,ISORT)/SQRT(4.D0*PI)*RL(IRAD,L,ISORT)
        ENDDO
        CALL CQD(H(ISORT),WORK1(0),WORK2,NRAD(ISORT)+1)
        CONVDRO(IGPTB,MY)=CONVDRO(IGPTB,MY)+WORK2(NRAD(ISORT))
C MAGNETIZATION CONVERGENCY, "Z" POLARIZATION
        DO IRAD=0,NRAD(ISORT)
        DMAGOUT=DRHO(IRAD,LM,IATOM,1)-DRHO(IRAD,LM,IATOM,NSPIN)
        DMAGINP=TRHO(IRAD,LM,IATOM,1)-TRHO(IRAD,LM,IATOM,NSPIN)
        WORK1(IRAD)=DCONJG(DMAGOUT-DMAGINP)*(DMAGOUT-DMAGINP)*
     &  WEIGHT(IRAD,ISORT)/SQRT(4.D0*PI)*RL(IRAD,L,ISORT)
        ENDDO
        CALL CQD(H(ISORT),WORK1(0),WORK2,NRAD(ISORT)+1)
        CONVDMG(0,IGPTB,MY)=CONVDMG(0,IGPTB,MY)+WORK2(NRAD(ISORT))
C MAGNETIZATION CONVERGENCY, "-" POLARIZATION
        DO IRAD=0,NRAD(ISORT)
        DMAGOUT=DMAG(IRAD,LM,IATOM,1)
        DMAGINP=TMAG(IRAD,LM,IATOM,1)
        WORK1(IRAD)=DCONJG(DMAGOUT-DMAGINP)*(DMAGOUT-DMAGINP)*
     &  WEIGHT(IRAD,ISORT)/SQRT(4.D0*PI)*RL(IRAD,L,ISORT)
        ENDDO
        CALL CQD(H(ISORT),WORK1(0),WORK2,NRAD(ISORT)+1)
        CONVDMG(-1,IGPTB,MY)=CONVDMG(-1,IGPTB,MY)+WORK2(NRAD(ISORT))
C MAGNETIZATION CONVERGENCY, "+" POLARIZATION
        DO IRAD=0,NRAD(ISORT)
        DMAGOUT=DMAG(IRAD,LM,IATOM,NSPIN)
        DMAGINP=TMAG(IRAD,LM,IATOM,NSPIN)
        WORK1(IRAD)=DCONJG(DMAGOUT-DMAGINP)*(DMAGOUT-DMAGINP)*
     &  WEIGHT(IRAD,ISORT)/SQRT(4.D0*PI)*RL(IRAD,L,ISORT)
        ENDDO
        CALL CQD(H(ISORT),WORK1(0),WORK2,NRAD(ISORT)+1)
        CONVDMG(+1,IGPTB,MY)=CONVDMG(+1,IGPTB,MY)+WORK2(NRAD(ISORT))
        ENDDO                                            !!! over m
        ENDDO                                            !!! over l
        ENDDO                                            !!! over atoms
        CONVDMO(IGPTB,MY)=CONVDMG(-1,IGPTB,MY)+
     &  CONVDMG(0,IGPTB,MY)+CONVDMG(+1,IGPTB,MY)
C SET OPTIMAL MIXING
        IF(NITER(IGPTB,MY).NE.0.AND.LBROY(IGPTB,MY).LT.0)
     &  CALL SCONVC(CONVDRO(IGPTB,MY),ITER,ADMIN,ADMAX,IGPTB,MY)
        IF(NITER(IGPTB,MY).NE.0.AND.LBROY(IGPTB,MY).LT.0)
     &  CALL SCONVM(CONVDMO(IGPTB,MY),ITER,ASMIN,ASMAX,IGPTB,MY)
        DPRATC(IGPTB,MY)=0.D0
        DPRATM(IGPTB,MY)=0.D0
        DO IATOM=1,NATOM
        DPRATC(IGPTB,MY)=DPRATC(IGPTB,MY)+0.5D0*DBLE(NSPIN)*
     &  ABS(DCHOUT(1,IATOM,1,IGPTB,MY)+
     &  DCHOUT(1,IATOM,NSPIN,IGPTB,MY))
        DPRATM(IGPTB,MY)=DPRATM(IGPTB,MY)+
     &  ABS(DCHOUT(1,IATOM,1,IGPTB,MY)-
     &  DCHOUT(1,IATOM,NSPIN,IGPTB,MY))+
     &  ABS(DMGOUT(1,IATOM,1,IGPTB,MY))+
     &  ABS(DMGOUT(1,IATOM,NSPIN,IGPTB,MY))
        ENDDO
        IF(LBROY(IGPTB,MY).LT.0)THEN
C FIND OPTIMAL ADMIXTURE
        CALL DPRATTC(DPRATC(IGPTB,MY),ITER,ADMIX1(IGPTB,MY),
     &  ADMIN(IGPTB,MY),ADMAX(IGPTB,MY),ADMOPT(IGPTB,MY),
     &  KEY(IGPTB,MY),IGPTB,MY)
        CALL DPRATTM(DPRATM(IGPTB,MY),ITER,ADMSPN(IGPTB,MY),
     &  ASMIN(IGPTB,MY),ASMAX(IGPTB,MY),ADSPIN(IGPTB,MY),
     &  KSP(IGPTB,MY),IGPTB,MY)
        ELSEIF(LBROY(IGPTB,MY).GE.0)THEN
C SET INPUT ADMIXTURE IF BROYDEN IS ON.
        ADMOPT(IGPTB,MY)=ADMIXH(IGPTB,MY)
        ADSPIN(IGPTB,MY)=ADMIXH(IGPTB,MY)
        ENDIF
1000 	CONTINUE                                         !!! over g-vectors
2000 	CONTINUE                                         !!! over polarizations
	IF(ITER.LT.1)RETURN
C CHECK MIXINGS
        DO MY=-1,2
        DO IGPTB=0,NGPTB
        IF(NITER(IGPTB ,MY).NE.0)THEN
        DO IGPTB1=0,NGPTB
        IF(INDGCON(IGPTB,IGPTB1).EQ.1)THEN
        IF(NITER(IGPTB1,MY).EQ.0)PRINT*,'<MIXDRO>::WRONG NITER'
        IF(NITER(IGPTB1,MY).EQ.0)NITER(IGPTB1,MY)=NITER(IGPTB,MY)
        ADM=MIN(ADMOPT(IGPTB,MY),ADMOPT(IGPTB1,MY))
        ADMOPT(IGPTB ,MY)=ADM
        ADMOPT(IGPTB1,MY)=ADM
        ADS=MIN(ADSPIN(IGPTB,MY),ADSPIN(IGPTB1,MY))
        ADSPIN(IGPTB, MY)=ADS
        ADSPIN(IGPTB1,MY)=ADS
        ENDIF
        ENDDO
        ENDIF
        ENDDO
        ENDDO
C ADMIX NEW AND OLD INDUCED CHARGE DENSITIES : [drho/dt]{inp}(i+1)
	DO 4000 MY=-1,2                                  !!! over polarizations
	DO 3000 IGPTB=0,NGPTB                            !!! over g-vectors
	IF(NITER(IGPTB,MY).EQ.0)GOTO3000
	CALL DROFILES(IGPTB,MY,IQPNT,32,'R')
        DO IATOM=1,NATOM
        ISORT=IS(IATOM)
        DO ISPIN=1,NSPIN
	ITRAN=ISPIN
        DO L=0,ILSV(ISORT)
        DO M=-L,L
        LM=L*(L+1)+M+1
        DO IRAD=0,NRAD(ISORT)
        TRHO(IRAD,LM,IATOM,ISPIN)=DRHO(IRAD,LM,IATOM,ISPIN)
        TMAG(IRAD,LM,IATOM,ITRAN)=DMAG(IRAD,LM,IATOM,ITRAN)
        ENDDO
        ENDDO
        ENDDO
        ENDDO
        ENDDO
	CALL DROFILES(IGPTB,MY,IQPNT,33,'R')
        DO IATOM=1,NATOM                                 !!! over atoms
        ISORT=IS(IATOM)
        DO L=0,ILSV(ISORT)                               !!! over l
	IF(L.GT.LBROY(IGPTB,MY))THEN
	DO M=-L,L                                        !!! over m
	LM=L*(L+1)+M+1
	DO IRAD=0,NRAD(ISORT)                            !!! over irad
C TOTAL INDUCED DENSITY
        DRHOOUT=(DRHO(IRAD,LM,IATOM,1)+DRHO(IRAD,LM,IATOM,NSPIN))/
     &  2.D0*DBLE(NSPIN)
        DRHOINP=(TRHO(IRAD,LM,IATOM,1)+TRHO(IRAD,LM,IATOM,NSPIN))/
     &  2.D0*DBLE(NSPIN)
        DRHONEW=ADMOPT(IGPTB,MY)*DRHOOUT+(1.D0-ADMOPT(IGPTB,MY))*
     &  DRHOINP
C INDUCED MAGNETIZATION ALONG Z
        DMAGOUT=DRHO(IRAD,LM,IATOM,1)-DRHO(IRAD,LM,IATOM,NSPIN)
        DMAGINP=TRHO(IRAD,LM,IATOM,1)-TRHO(IRAD,LM,IATOM,NSPIN)
        DMAGNEW=ADSPIN(IGPTB,MY)*DMAGOUT+(1.D0-ADSPIN(IGPTB,MY))*
     &  DMAGINP
        DRHO(IRAD,LM,IATOM,1    )=(DRHONEW+DMAGNEW)/DBLE(NSPIN)
        DRHO(IRAD,LM,IATOM,NSPIN)=(DRHONEW-DMAGNEW)/DBLE(NSPIN)
C INDUCED MAGNETIZATION ALONG "-/+"
        DO ITRAN=1,NSPIN
        DMAGOUT=DMAG(IRAD,LM,IATOM,ITRAN)
        DMAGINP=TMAG(IRAD,LM,IATOM,ITRAN)
        DMAGNEW=ADSPIN(IGPTB,MY)*DMAGOUT+(1.D0-ADSPIN(IGPTB,MY))*
     &  DMAGINP
        DMAG(IRAD,LM,IATOM,ITRAN)=DMAGNEW
        ENDDO
	ENDDO                                            !!! over irad
	ENDDO                                            !!! over m
	ENDIF
	ENDDO                                            !!! over l
	ENDDO                                            !!! over atoms
	CALL DROFILES(IGPTB,MY,IQPNT,32,'W')
	CALL DROFILES(IGPTB,MY,IQPNT,33,'W')
3000	CONTINUE                                         !!! over g-vectors
4000	CONTINUE                                         !!! over polarizations
C  PRINT INFORMATION
        WRITE(IUN,1010)
        IF(IUN.NE.IUT)WRITE(IUT,1010)
        DO 6000 MY=-1,2                      !!! over polarizations
        DO 5000 IGPTB=0,NGPTB                !!! over g-vectors
        WRITE(IUN,1020)POL(MY)
        WRITE(IUN,1021)IGPTB,GPTB(1,IGPTB),GPTB(2,IGPTB),GPTB(3,IGPTB)
        IF(NITER(IGPTB,MY).EQ.0)WRITE(IUN,1090)
        IF(NITER(IGPTB,MY).EQ.0.AND.IUN.NE.IUT)WRITE(IUT,1090)
        IF(NITER(IGPTB,MY).EQ.0)GOTO5000
        IF(LBROY(IGPTB,MY).LT.0)
     &  WRITE(IUN,1030)ADMOPT(IGPTB,MY),ADMIN(IGPTB,MY),
     &  ADMAX(IGPTB,MY),ADSPIN(IGPTB,MY)
        IF(LBROY(IGPTB,MY).GE.0)
     &  WRITE(IUN,1040)ADMIXB(IGPTB,MY),ADMOPT(IGPTB,MY)
        WRITE(IUN,1050)
     &  SQRT(CONVDRO(   IGPTB,MY))
        WRITE(IUN,1060)
     &  SQRT(CONVDMG( 0,IGPTB,MY))
        WRITE(IUN,1070)
     &  SQRT(CONVDMG(-1,IGPTB,MY))
        WRITE(IUN,1080)
     &  SQRT(CONVDMG(+1,IGPTB,MY))
        IF(IUN.EQ.IUT)GOTO5000
        WRITE(IUT,1020)POL(MY)
        WRITE(IUT,1021)IGPTB,GPTB(1,IGPTB),GPTB(2,IGPTB),GPTB(3,IGPTB)
        IF(LBROY(IGPTB,MY).LT.0)
     &  WRITE(IUT,1030)ADMOPT(IGPTB,MY),ADMIN(IGPTB,MY),
     &  ADMAX(IGPTB,MY),ADSPIN(IGPTB,MY)
        IF(LBROY(IGPTB,MY).GE.0)
     &  WRITE(IUT,1040)ADMIXB(IGPTB,MY),ADMOPT(IGPTB,MY)
        WRITE(IUT,1050)
     &  SQRT(CONVDRO(   IGPTB,MY))
        WRITE(IUT,1060)
     &  SQRT(CONVDMG( 0,IGPTB,MY))
        WRITE(IUT,1070)
     &  SQRT(CONVDMG(-1,IGPTB,MY))
        WRITE(IUT,1080)
     &  SQRT(CONVDMG(+1,IGPTB,MY))
5000    CONTINUE                            !!! over polarizations
6000    CONTINUE                            !!! over polarizations
C CHECK FOR CONVERGENCY
        DO MY=-1,2
        DO IGPTB=0,NGPTB
        IF(NITER(IGPTB,MY).NE.0)THEN
        EXDRHO=SQRT(CONVDRO(IGPTB,MY))
        EXDMOM=SQRT(CONVDMO(IGPTB,MY))
        IF(EXDRHO.LE.EPS(IGPTB,MY).AND.EXDMOM.LE.EPS(IGPTB,MY))
     &  NITER(IGPTB,MY)=0
        ENDIF
        ENDDO
        ENDDO
C CHECK FOR CONVERGENCY
        DO MY=-1,2
        DO IGPTB=0,NGPTB
        IF(NITER(IGPTB,MY).NE.0)THEN
        DO IGPTB1=0,NGPTB
        IF(INDGCON(IGPTB,IGPTB1).EQ.1)THEN
        IF(NITER(IGPTB1,MY).NE.NITER(IGPTB,MY))THEN
        MAXITER=MAX(NITER(IGPTB1,MY),NITER(IGPTB,MY))
        NITER(IGPTB, MY)=MAXITER
        NITER(IGPTB1,MY)=MAXITER
        ENDIF
        ENDIF
        ENDDO
        ENDIF
        ENDDO
        ENDDO
C CHECK FOR EXITING
        NIT=0
        DO MY=-1,2
        DO IGPTB=0,NGPTB
        NIT=NIT+NITER(IGPTB,MY)
        ENDDO
        ENDDO
        IF(NIT.NE.0)EXIT=.FALSE.
        IF(NIT.EQ.0)EXIT=.TRUE.
C SET MODE=2
        IF(ITER.EQ.1)MODE=2
1010    FORMAT(1X,'***** Results from the linear-mixing subroutines ->')
1020    FORMAT(1X,'MAGNETIC FIELD POLARIZATION  "',A1,'" ')
1021    FORMAT(1X,'G',I2,'=(',G12.5,',',G12.5,',',G12.5,')')
1030    FORMAT(1X,'Opt,min,max,spn mix =',4(G12.5,1X))
1040    FORMAT(1X,'Broyden is on! bmix =',2(G12.5,1X))
1050    FORMAT(1X,'Density Convergence =',2(G12.5,1X))
1060    FORMAT(1X,'Z-magn. Convergence =',2(G12.5,1X))
1070    FORMAT(1X,'M-magn. Convergence =',2(G12.5,1X))
1080    FORMAT(1X,'P-magn. Convergence =',2(G12.5,1X))
1090    FORMAT(1X,'Self-Consistensy either done or not performed.')
	END




        SUBROUTINE DPRATTC(A,ITER,ADM0,ADMIN,ADMAX,ADM,KEY,IGPTB,MY)
************************************************************
*  Optimal admixture choice in solving the equation:       *
*                         A=F[A]                           *
*  according to the Pratt scheme.                          *
************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        DIMENSION AINPIM1(0:NENVMAX,-1:2),AINPI(0:NENVMAX,-1:2)
     &    ,AINPIP1(0:NENVMAX,-1:2),AOUTIM1(0:NENVMAX,-1:2)
     &    ,AOUTI(0:NENVMAX,-1:2)
        SAVE AINPIM1,AINPI,AOUTIM1,AOUTI,AINPIP1
C  SET INPUT AND OUTPUT VALUES
        AINPIM1(IGPTB,MY)=AINPI(IGPTB,MY)         !!! A(inp,i-1)=A(inp,i)
        AINPI(IGPTB,MY)=AINPIP1(IGPTB,MY)         !!! A(inp,i)=A(inp,i+1)
        AOUTIM1(IGPTB,MY)=AOUTI(IGPTB,MY)         !!! A(out,i-1)=A(out,i)
        AOUTI(IGPTB,MY)=A                         !!! A(out,i)=A coming now
C  FIND OPTIMAL ADMIXTURE
        IF(ITER.EQ.1.AND.KEY.EQ.1)THEN
        ADM=1.D0
        ELSEIF(ITER.EQ.1.AND.KEY.EQ.0)THEN
        ADM=ADM0
        ELSEIF(ITER.EQ.2.OR.ITER.EQ.3)THEN
        ADM=ADM0
        ELSE                  !!! optimal admixture choice
        DIF=(AOUTI(IGPTB,MY)-AINPI(IGPTB,MY))-
     &  (AOUTIM1(IGPTB,MY)-AINPIM1(IGPTB,MY))
C       IF(ABS(DIF).LE.1.D-14)PRINT*,'SOMETHING IS WRONG IN <DPRATTC>'
        ADM=(AINPIM1(IGPTB,MY)-AINPI(IGPTB,MY))/(DIF+1.D-14)
        ENDIF
        IF(ADM.LE.ADMIN)ADM=ADMIN
        IF(ADM.GE.ADMAX)ADM=ADMAX
C  FIND INPUT FOR THE NEXT ITERATION
        AINPIP1(IGPTB,MY)=AOUTI(IGPTB,MY)*ADM+
     &  AINPI(IGPTB,MY)*(1.D0-ADM) !!! A(inp,i+1)
        END

        SUBROUTINE DPRATTM(A,ITER,ADM0,ADMIN,ADMAX,ADM,KEY,IGPTB,MY)
************************************************************
*  Optimal admixture choice in solving the equation:       *
*                         A=F[A]                           *
*  according to the Pratt scheme.                          *
************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        DIMENSION AINPIM1(0:NENVMAX,-1:2),AINPI(0:NENVMAX,-1:2)
     &    ,AINPIP1(0:NENVMAX,-1:2),AOUTIM1(0:NENVMAX,-1:2)
     &    ,AOUTI(0:NENVMAX,-1:2)
        SAVE AINPIM1,AINPI,AOUTIM1,AOUTI,AINPIP1
C  SET INPUT AND OUTPUT VALUES
        AINPIM1(IGPTB,MY)=AINPI(IGPTB,MY)         !!! A(inp,i-1)=A(inp,i)
        AINPI(IGPTB,MY)=AINPIP1(IGPTB,MY)         !!! A(inp,i)=A(inp,i+1)
        AOUTIM1(IGPTB,MY)=AOUTI(IGPTB,MY)         !!! A(out,i-1)=A(out,i)
        AOUTI(IGPTB,MY)=A                         !!! A(out,i)=A coming now
C  FIND OPTIMAL ADMIXTURE
        IF(ITER.EQ.1.AND.KEY.EQ.1)THEN
        ADM=1.D0
        ELSEIF(ITER.EQ.1.AND.KEY.EQ.0)THEN
        ADM=ADM0
        ELSEIF(ITER.EQ.2.OR.ITER.EQ.3)THEN
        ADM=ADM0
        ELSE                  !!! optimal admixture choice
        DIF=(AOUTI(IGPTB,MY)-AINPI(IGPTB,MY))-
     &  (AOUTIM1(IGPTB,MY)-AINPIM1(IGPTB,MY))
C       IF(ABS(DIF).LE.1.D-14)PRINT*,'SOMETHING IS WRONG IN <DPRATTM>'
        ADM=(AINPIM1(IGPTB,MY)-AINPI(IGPTB,MY))/(DIF+1.D-14)
        ENDIF
        IF(ADM.LE.ADMIN)ADM=ADMIN
        IF(ADM.GE.ADMAX)ADM=ADMAX
C  FIND INPUT FOR THE NEXT ITERATION
        AINPIP1(IGPTB,MY)=AOUTI(IGPTB,MY)*ADM+
     &  AINPI(IGPTB,MY)*(1.D0-ADM) !!! A(inp,i+1)
        END


        SUBROUTINE SCONVC(A,ITER,ADMIN,ADMAX,IGPTB,MY)
************************************************************
*  Checks whether the self-consistent cycle converges.     *
************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        DIMENSION ADMIN(0:NENVMAX,-1:2),ADMAX(0:NENVMAX,-1:2)
     &   ,AOLD(2,0:NENVMAX,-1:2)
        SAVE AOLD
C  SAVE DATA OF PREVIOUS THREE ITERATIONS
        IF(ITER.EQ.1)THEN
        AOLD(1,IGPTB,MY)=0.D0
        AOLD(2,IGPTB,MY)=0.D0
        ELSEIF(ITER.GT.1)THEN
        AOLD(2,IGPTB,MY)=AOLD(1,IGPTB,MY)
        AOLD(1,IGPTB,MY)=A
        ENDIF
C  CHECK WHETHER CONVERGENCY IS TAKEN PLACE
        IF(ITER.GT.3)THEN
        IF(AOLD(1,IGPTB,MY).LT.AOLD(2,IGPTB,MY))RETURN
        ADMIN(IGPTB,MY)=ADMIN(IGPTB,MY)/2.D0
        ADMAX(IGPTB,MY)=ADMAX(IGPTB,MY)/2.D0
        ENDIF
        END

        SUBROUTINE SCONVM(A,ITER,ADMIN,ADMAX,IGPTB,MY)
************************************************************
*  Checks whether the self-consistent cycle converges.     *
************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        DIMENSION ADMIN(0:NENVMAX,-1:2),ADMAX(0:NENVMAX,-1:2)
     &    ,AOLD(2,0:NENVMAX,-1:2)
        SAVE AOLD
C  SAVE DATA OF PREVIOUS THREE ITERATIONS
        IF(ITER.EQ.1)THEN
        AOLD(1,IGPTB,MY)=0.D0
        AOLD(2,IGPTB,MY)=0.D0
        ELSEIF(ITER.GT.1)THEN
        AOLD(2,IGPTB,MY)=AOLD(1,IGPTB,MY)
        AOLD(1,IGPTB,MY)=A
        ENDIF
C  CHECK WHETHER CONVERGENCY IS TAKEN PLACE
        IF(ITER.GT.3)THEN
        IF(AOLD(1,IGPTB,MY).LT.AOLD(2,IGPTB,MY))RETURN
CCC     ADMIN(IGPTB,MY)=ADMIN(IGPTB,MY)/2.D0
CCC     ADMAX(IGPTB,MY)=ADMAX(IGPTB,MY)/2.D0
        ENDIF
        END
