	SUBROUTINE RUNTASK
************************************************************
*  Selects polarizations to run.                           *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &   ,ILSV(NSORTMAX),NITER(0:NENVMAX,-1:2)
	CHARACTER TEXQ*10,TXTEL(NSORTMAX)*10,TXTSP(2)*2
     &   ,TEXM*60,TASK*10
	LOGICAL LPOL(-1:2)
        COMMON /CONTROL/ LIFT,LMTO,NSPH,NINT,NPF,MODE        !!! from init
        COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from init
        COMMON /MAGCOM/  ITERMAX,NITER                       !!! from init
        COMMON /TXTEL/   TXTEL,TXTSP,TEXQ,TEXM,TASK          !!! from init
	COMMON /UNIT/    IUN                                 !!! from init
C CONVERT TO LOW-CASE LETTERS
	CALL CONVLOW(TEXM,60)
	TASK='          '
C SEARCH FOR CONTROL SYMBOLS <>
	IF(TEXM(1:1).EQ.'<')THEN             !!! if '<'
	TEXM(1:1)=' '
	ITSK=0
	DO IL=2,60                           !!! over il
	IF(TEXM(IL:IL).EQ.'>')THEN
	TEXM(IL:IL)=' '
	EXIT
	ENDIF
	ITSK=ITSK+1
	IF(ITSK.GT.10)
     &  STOP'<Q-VECTOR>:: TOO MANY CHARACTERS IN <TASK>'
	TASK(ITSK:ITSK)=TEXM(IL:IL)
	TEXM(IL:IL)=' '
	ENDDO                                !!! over il
	ELSEIF(TEXM(1:3).EQ.'all')THEN       !!! if 'all'
	TEXM(1:3)='   '
	ELSE
	DO IL=1,60
	IF(TEXM(IL:IL).EQ.'m'.OR.
     &     TEXM(IL:IL).EQ.'p'.OR.
     &     TEXM(IL:IL).EQ.'z'.OR.
     &     TEXM(IL:IL).EQ.'v')THEN
	TASK(1:1)=TEXM(IL:IL)
	EXIT
	ENDIF
	ENDDO
	ENDIF                                !!! endif
C COMPUTE HOW MANY POLARIZATIONS TO RUN
	NMZPV=0
	DO IL=1,60
	IF(TEXM(IL:IL).EQ.'m'.OR.
     &	   TEXM(IL:IL).EQ.'p'.OR.
     &	   TEXM(IL:IL).EQ.'z'.OR.
     &     TEXM(IL:IL).EQ.'v')NMZPV=NMZPV+1
	ENDDO
C SET LOGICAL ARRAY
	DO MY=-1,2
	IF(NMZPV.EQ.0)LPOL(MY)=.TRUE.
	IF(NMZPV.NE.0)LPOL(MY)=.FALSE.
	ENDDO
C SELECT POLARIZATIONS TO RUN
	DO IL=1,60
	IF(TEXM(IL:IL).EQ.'m'.OR.
     &	   TEXM(IL:IL).EQ.'p'.OR.
     &	   TEXM(IL:IL).EQ.'z'.OR.
     &     TEXM(IL:IL).EQ.'v')THEN
	IF(TEXM(IL:IL).EQ.'m')MY=-1
	IF(TEXM(IL:IL).EQ.'p')MY=+1
	IF(TEXM(IL:IL).EQ.'z')MY= 0
	IF(TEXM(IL:IL).EQ.'v')MY= 2
	TEXM(IL:IL)=' '
	LPOL(MY)=.TRUE.
	ENDIF
	ENDDO
C SET NUMBER OF ITERATIONS TO ZERO 
	DO MY=-1,2
	DO IGPTB=0,NENVMAX
	IF(.NOT.LPOL(MY))NITER(IGPTB,MY)=0
	ENDDO
	ENDDO
        END
