C*************************************************************
C
	SUBROUTINE EFSEARCH(X1,Y0,X0)
C Written by Yu.A.Uspensky (FIAN)
C
	IMPLICIT REAL*8 (A-H,O-Z)
	LOGICAL LEFT,RIGHT
	COMMON /COMFERM/ITMAX,EPS,H
	COMMON /LTRT/X,YY,DY,XL,YYL,DYL,LEFT,XR,YYR,DYR,RIGHT
C
	F1(A,B)=2.D0*A/(1.D0+SQRT(1.+4.D0*A*(B-1)))
	F2(C,D)=2.D0/(C+SQRT(C*C+4.D0*(D-C)))
C
C		INITIATION
	ITER=1
	H1=1.D0/H
	X=X1
	LEFT=.FALSE.
	RIGHT=.FALSE.
C
C	THE BEGINNING OF THE ITERATION LOOP.
C
1	CALL TTRINT1(X,Y,DY,0)
C	DY=DY/DX
	YY=Y-Y0
C	PRINT*,'ITER,X,YY',ITER,X,YY  !!!DEBUGGING
	CALL SLTRT
	IF(.NOT.LEFT.OR..NOT.RIGHT) THEN
C	THE NEWTON'S METHOD.
	  IF(DY.LE.ABS(YY*H1)) X=X-SIGN(H,YY)
C		WITH LIMITATION
	  IF(DY.GT.ABS(YY*H1)) X=X-YY/DY
C		WITHOUT LIMITATION
	ELSE IF(LEFT.AND.RIGHT) THEN
C	THE PARABOLA METHOD.
	  DELTX=XR-XL
	  IF(DELTX.LE.1.D-10)GOTO 2
	  DYS=(YYR-YYL)/DELTX
	  IF(ABS(YYL).LE.YYR) THEN
	    ALFA=ABS(YYL/DELTX)
	    IF(ALFA.LE.DYL) THEN
	      A=ALFA/DYL
	      B=DYS/DYL
	      X=XL+DELTX*F1(A,B)
	    ELSE
	      C=DYL/ALFA
	      D=DYS/ALFA
	      X=XL+DELTX*F2(C,D)
	    END IF
	  ELSE
	    BETA=YYR/DELTX
	    IF(BETA.LE.DYR) THEN
	      A=BETA/DYR
	      B=DYS/DYR
	      X=XR-DELTX*F1(A,B)
	    ELSE
	      C=DYR/BETA
	      D=DYS/BETA
	      X=XR-DELTX*F2(C,D)
	    END IF
	  END IF
	END IF
C		EXITS
	IF(ITER.GE.ITMAX)STOP'THE EXCEEDING OF ITMAX IN EFERMI_SEARCH'
	IF(ABS(YY).LE.EPS) GO TO 2
C
	ITER=ITER+1
	GO TO 1
C
C		THE END OF THE LOOP.
C
2	IF(ITER.NE.1)THEN
	 X0=X
	ELSE
	 X0=X1
	ENDIF
	RETURN
	END
