	SUBROUTINE CHANN
**********************************************************************
*  Allocation of different channels inside the program:              *
*     Channel:   Description:                       Storage:         *
*       01      Read all input files                                 *
*       02      Standard output to OUTFILE         Permanent         *
*  E    03      Additional output channel          Permanent         *
*  L    04      Still empty                                          *
*  E    05      Terminal Input                                       *
*  C    06      Terminal Output                                      *
*  T    07      Madelung's constants               Temporary         *
*  R    08      Structure constants CONFILE    Permanent/Temporary   *
*  O    09      Cell description                   Temporary         *
*  N    10      Energy bands BNDFILE           Permanent/Temporary   *
*  S    11      Cell constants SRFFILE         Permanent/Temporary   *
*       12      Empty                                                *
*  F    13      Potential parameters NMT           Temporary         *
*  I    14      Wave functions for one k-point     Temporary         *
*  L    15      Wave functions PSIFILE         Permanent/Temporary   *
*  E    16      Pulay forces                       Temporary         *
*  S    17      Density of states data             Temporary         *
*       18      Potential parameters INT           Temporary         *
*       19      Pseudodensity parameters           Temporary         *
*       20      Pulay force parameters             Temporary         *
*       21      Number of states matrix            Temporary         *
*       22      Fat bands data                     Permanent         *
*       23      Broyden mixing                     Temporary         *
*       24      Empty                                                *
**********************************************************************
*       25      Polarizability PLZFILE             Permanent         *
*  L    26      Pseudopolarizability PLSFILE       Permanent         *
*  I    27      Polarizabilty                      Temporary         *
*  N    28      Pseudopolarizability               Temporary         *
*  E    29      Stoner matrix (not ready)          Permanent         *
*  A    30      Induced charge density             Temporary         *
*  R    31      Induced pseudodensity              Temporary         *
*       32      Induced charge density DROFILE     Permanent         *
*  R    33      Induced charge density             Temporary         *
*  E    34      Induced pseudodensity  DPSFILE     Permanent         *
*  S    35      Induced pseudodensity              Temporary         *
*  P    36      Induced potential DSVFILE      Permanent/Temporary   *
*  O    37      Induced pseudopot.DPVFILE      Permanent/Temporary   *
*  N    38      Empty                                                *
*  S    39      Tetrahedron weights                Temporary         *
*  E    40      Tetrahedron weights WGTFILE        Permanent         *
*       41      Change in NMT parameters           Temporary         *
*  F    42      Change in TOS matrix               Temporary         *
*  I    43      Change in BMT parameters           Temporary         *
*  L    44      Change in BOS matrix               Temporary         *
*  E    45      Dynamical matrix data              Temporary         *
*  S    46      Induced INT parameters             Temporary         *
*       47      Induced pseudodensity data         Temporary         *
*       48      Dynamical matrix data              Temporary         *
*       49                                                           *
*       50                                                           *
**********************************************************************
	END
