	SUBROUTINE MAGFILE           
************************************************************
*  <MAGFILE> checks file storage.                          *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &   ,ILSV(NSORTMAX),NHSORT(NSORTMAX),NDIV(3),NDIW(3)
	CHARACTER*60 INIFILE,SC0FILE,STRFILE,SCRFILE(100)
     &   ,HUBFILE,HOPFILE,OPTFILE,ENRFILE,PNTFILE,TXTSCR
     &   ,CONFILE,FTRFILE,KOVFILE,PSIFILE,TMPFILE,BNDFILE
     &   ,POTFILE,FATFILE,DOSFILE,SCFFILE,OUTFILE,LRTFILE
     &   ,INPFOLD
	CHARACTER TXTEL(NSORTMAX)*10,TXTSP(2)*2
        LOGICAL EXIST
C Controls:
	COMMON /CONTROL/ LIFT,LMTO,NCOU,NINT,NPFR,MODE       !!! from readini
	COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from readini
	COMMON /ORBS/    NORBS                               !!! from readini
	COMMON /SPIN/    NSPIN                               !!! from readini
C K-mesh:
        COMMON /INTTR/   NDIV,NDIW                           !!! from readini
C Additional inputs:
	COMMON /INP0/    INIFILE,SC0FILE,STRFILE,LRTFILE,INPFOLD              
        COMMON /INP1/    ICHUB,ICHOP,ICOPT,ICENR,ICPNT       !!! from readini
        COMMON /INP2/    HUBFILE,HOPFILE,OPTFILE,ENRFILE,PNTFILE
C Outputs:
	COMMON /OUT0/    SCRFILE                             !!! from readini
	COMMON /OUT1/    ICCON,ICFTR,ICKOV,ICPSI,ICTMP,ICBND !!! from readini
     &                  ,ICPOT,ICFAT,ICDOS,ICSCF,ICOUT
	COMMON /OUT2/    CONFILE,FTRFILE,KOVFILE,PSIFILE,TMPFILE
     &                  ,BNDFILE,POTFILE,FATFILE,DOSFILE,SCFFILE
     &                  ,OUTFILE
	COMMON /TXTEL/   TXTEL,TXTSP                         !!! from readini
        COMMON /SCRDIR/  TXTSCR                              !!! from block
	COMMON /UNIT/    IUN                                 !!! from readini
	DATA PI/3.141592653589793D0/                             
        NF=INDEX(INPFOLD,' ')
C  SET PATH TO THE INPUT FILES
C  Hubfile:
        NB=INDEX(HUBFILE,' ')
        IF(NB.EQ.1)HUBFILE(1:3)='hub'
        IF(NB.EQ.1)NB=4
        HUBFILE=INPFOLD(1:NF-1)//HUBFILE(1:NB-1)
C  Hopfile:
        NB=INDEX(HOPFILE,' ')
        IF(NB.EQ.1)HOPFILE(1:3)='hop'
        IF(NB.EQ.1)NB=4
        HOPFILE=INPFOLD(1:NF-1)//HOPFILE(1:NB-1)
C  Optfile:
        NB=INDEX(OPTFILE,' ')
        IF(NB.EQ.1)OPTFILE(1:3)='opt'
        IF(NB.EQ.1)NB=4
        OPTFILE=INPFOLD(1:NF-1)//OPTFILE(1:NB-1)
C  Enrfile:
        NB=INDEX(ENRFILE,' ')
        IF(NB.EQ.1)ENRFILE(1:3)='enr'
        IF(NB.EQ.1)NB=4
        ENRFILE=INPFOLD(1:NF-1)//ENRFILE(1:NB-1)
C  Pntfile:
        NB=INDEX(PNTFILE,' ')
        IF(NB.EQ.1)PNTFILE(1:3)='pnt'
        IF(NB.EQ.1)NB=4
        PNTFILE=INPFOLD(1:NF-1)//PNTFILE(1:NB-1)
C  Confile:
        NB=INDEX(CONFILE,' ')
        IF(NB.EQ.1)CONFILE(1:3)='con'
        IF(NB.EQ.1)NB=4
        CONFILE=INPFOLD(1:NF-1)//CONFILE(1:NB-1)
C  Ftrfile:
        NB=INDEX(FTRFILE,' ')
        IF(NB.EQ.1)FTRFILE(1:3)='ftr'
        IF(NB.EQ.1)NB=4
        FTRFILE=INPFOLD(1:NF-1)//FTRFILE(1:NB-1)
C  Kovfile:
        NB=INDEX(KOVFILE,' ')
        IF(NB.EQ.1)KOVFILE(1:3)='kov'
        IF(NB.EQ.1)NB=4
        KOVFILE=INPFOLD(1:NF-1)//KOVFILE(1:NB-1)
C  Psifile:
        NB=INDEX(PSIFILE,' ')
        IF(NB.EQ.1)PSIFILE(1:3)='psi'
        IF(NB.EQ.1)NB=4
        PSIFILE=INPFOLD(1:NF-1)//PSIFILE(1:NB-1)
C  Tmpfile not defined yet
C       NB=INDEX(CONFILE,' ')
C       IF(NB.EQ.1)TMPFILE(1:3)='tmp'
C       IF(NB.EQ.1)NB=4
C       TMPFILE=INPFOLD(1:NF-1)//TMPFILE(1:NB-1)
C  Bndfile:
        NB=INDEX(BNDFILE,' ')
        IF(NB.EQ.1)BNDFILE(1:3)='bnd'
        IF(NB.EQ.1)NB=4
        BNDFILE=INPFOLD(1:NF-1)//BNDFILE(1:NB-1)
C  Potfile:
        NB=INDEX(POTFILE,' ')
        IF(NB.EQ.1)POTFILE(1:3)='pot'
        IF(NB.EQ.1)NB=4
        POTFILE=INPFOLD(1:NF-1)//POTFILE(1:NB-1)
C  Fatfile:
        NB=INDEX(FATFILE,' ')
        IF(NB.EQ.1)FATFILE(1:3)='fat'
        IF(NB.EQ.1)NB=4
        FATFILE=INPFOLD(1:NF-1)//FATFILE(1:NB-1)
C  Dosfile:
        NB=INDEX(DOSFILE,' ')
        IF(NB.EQ.1)DOSFILE(1:3)='dos'
        IF(NB.EQ.1)NB=4
        DOSFILE=INPFOLD(1:NF-1)//DOSFILE(1:NB-1)
C  Scffile:
        NB=INDEX(SCFFILE,' ')
        IF(NB.EQ.1)SCFFILE(1:3)='scf'
        IF(NB.EQ.1)NB=4
        SCFFILE=INPFOLD(1:NF-1)//SCFFILE(1:NB-1)
C  CHECK FILES FOR OPENNING
C  Enrfile:
        INQUIRE(FILE=ENRFILE,EXIST=EXIST)
        IF(.NOT.EXIST)
     &  PRINT*,'<READLRT>:: ENRFILE DOES NOT EXIST, WILL BE CREATED'
        IF(EXIST.AND.MODE.EQ.0)
     &  STOP'<READLRT>:: ENRFILE SHOULD NOT EXIST IF MODE=0'
        IF(.NOT.EXIST.AND.NDIV(1).NE.NDIW(1))
     &  STOP'<MAGFILE>:: NDIV.NE.NDIW, ENRFILE CANNOT BE CREATED'
C  Pntfile:
        INQUIRE(FILE=PNTFILE,EXIST=EXIST)
        IF(.NOT.EXIST)
     &  STOP'<MAGFILE>:: PNTFILE MUST EXIST'
C  Confile:
        INQUIRE(FILE=CONFILE,EXIST=EXIST)
        IF(EXIST.AND.ICCON.EQ.1)THEN
        PRINT*,'<MAGFILE>:: CONFILE EXIST, WILL BE CHECKED'
        ICCON=2
        ELSEIF(.NOT.EXIST.AND.ICCON.EQ.2)THEN
        PRINT*,'<MAGFILE>:: CONFILE DOES NOT EXIST, WILL BE CREATED'
        ICCON=1
        ENDIF
C  Bndfile:
        IF(ICBND.NE.ICPSI)STOP'<MAGFILE>:: KEYS FOR BNDFILE AND PSIFILE
     &  MUST BE THE SAME'
        INQUIRE(FILE=BNDFILE,EXIST=EXIST)
        IF(EXIST.AND.ICBND.EQ.1)THEN
        PRINT*,'<MAGFILE>:: BNDFILE EXIST, WILL BE CHECKED'
        ICBND=2
        ELSEIF(.NOT.EXIST.AND.ICBND.EQ.2)THEN
        PRINT*,'<MAGFILE>:: BNDFILE DOES NOT EXIST, WILL BE CREATED'
        ICBND=1
        ENDIF
C  Psifile:
        INQUIRE(FILE=PSIFILE,EXIST=EXIST)
        IF(EXIST.AND.ICPSI.EQ.1)THEN
        PRINT*,'<MAGFILE>:: PSIFILE EXIST, WILL BE CHECKED'
        ICPSI=2
        ELSEIF(.NOT.EXIST.AND.ICPSI.EQ.2)THEN
        PRINT*,'<MAGFILE>:: PSIFILE DOES NOT EXIST, WILL BE CREATED'
        ICPSI=1
        ENDIF
        IF(ICBND.NE.ICPSI)STOP'<MAGFILE>:: BNDFILE AND PSIFILE
     &  MUST EITHER BOTH EXIST OR BOTH ABSENT'
	END
