	SUBROUTINE PRINTQ(IQPNT)
*****************************************************************
*  Prints susceptibility calculated by CHITET subroutine.       *
*****************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &   ,IKOV(NOPRMAX),NDIV(3),IG0IG1(KMAX,NOPRMAX)
     &   ,IGS(0:50,0:50,0:50),ISG(NOPRMAX,NOPRMAX)
     &   ,IK0IK1(KMAX,NOPRMAX),KSYMPN(NOPRMAX,KMAX)
     &   ,MSYMPN(NOPRMAX,KMAX),NDIW(3),NBNDC(NPANMAX)
	DIMENSION PNT(3,KMAX),EARR(NDIMMAX*NSPINMAX,KMAX,NPANMAX)
     &   ,WEIGH(NDIMMAX*NSPINMAX,KMAX),QB(3,3),RB(3,3),WGTQ(4)
     &   ,WEIGD(NDIMMAX*NSPINMAX,KMAX),WTST(6,NBNDMAX*NSPINMAX)
     &   ,WEIGQ(NBNDMAX*NSPINMAX,NBNDMAX*NSPINMAX,6,4)
     &   ,WGTOM(NBNDMAX*NSPINMAX,NBNDMAX*NSPINMAX,4,4)
     &   ,CHIQ(NBNDMAX*NSPINMAX,NBNDMAX*NSPINMAX,8)
     &   ,WEIGK(NBNDMAX*NSPINMAX,4,4),WGT(KMAX),QPNT(3)
     &   ,TOSK(2),DOSK(2),TOSQ(2),DOSQ(2),TWGT(2),ORTH(2:3)
     &   ,CHIM(2),CHI0(2)
	CHARACTER*60 DSFFILE,PHNFILE,TMPFILE,WGTFILE(10)
     &   ,SCRFILE(100),FILE
	LOGICAL EXIST
C Controls: 
	COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE            !!! from readini
	COMMON /ORBS/   NORBS                                   !!! from readini
	COMMON /SPIN/   NSPIN                                   !!! from readini
        COMMON /WHICOM/ NWHI,LWHI,IWHI                          !!! from readlrt
C Inputs:
	COMMON /KAPPAR/ NPAN                                    !!! from readini
        COMMON /LATPAR/ PAR,ORTH,OMEGAC                         !!! from readini
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT,NBNDC,POLUS           !!! from readini
C Bands:
	COMMON /ENERGY/ EARR,WEIGH,WEIGD                        !!! from lmtbnd
	COMMON /EFERMI/ EF                                      !!! from ttrint1
C Group: 
	COMMON /GROUPOUT/NGROUP                                 !!! from group
	COMMON /SUBGROUP/NSGQ,NGEQ,ISG,KSYMPN,MSYMPN,IGS        !!! from symmsh
	COMMON /SYMMESH/IG0IG1,IK0IK1                           !!! from symmsh
	COMMON /INVERS/ INV,IKOV                                !!! from group
C K-mesh:
	COMMON /QMESH/  NQPNT,QPNT                              !!! from qvector
	COMMON /MESH/   NPNT,PNT,WGT                            !!! from ttrmsh
	COMMON /INTTR/  NDIV,NDIW                               !!! from readini
C Frequency:
        COMMON /FREQU/  OMGR                                    !!! from init
C Temporary:
        COMMON /STORE1/ WEIGQ,WGTOM                             !!! tmp.storage
C Outputs:
	COMMON /OUT0/   SCRFILE                                 !!! from qvector
	COMMON /OUT1PH/ ICDSF,ICDRO,ICPHN,ICTMP,ICDSV,ICWGT     !!! from qvector
	COMMON /OUT2PH/ DSFFILE,PHNFILE,TMPFILE,WGTFILE         !!! from qvector
	COMMON /WORD/   NVAL                                    !!! from block
	COMMON /UNIT/   IUN                                     !!! from readini
	DATA PI/3.141592653589793D0/,NODEBUG/0/,EPS/1.D-10/
	IF(LWHI.NE.1)RETURN
	IF(ICWGT.NE.0)FILE=WGTFILE(LWHI)
	IF(ICWGT.EQ.0)FILE=SCRFILE(40)
        INQUIRE(FILE=FILE,RECL=NRECL)
CWRONG  IF(WRONG)THEN                !!! wrong compiler option
        NRECL=NVAL
        OPEN(UNIT=40,FILE=FILE,STATUS='OLD',FORM='UNFORMATTED',
     &  ACCESS='DIRECT',RECL=NRECL)
        READ(40,REC=1)NRECL
        CLOSE(40)
CWRONG  ENDIF
	OPEN(UNIT=40,FILE=FILE,STATUS='OLD',
     &  FORM='UNFORMATTED',ACCESS='DIRECT',RECL=NRECL)
C  TEST WEIGHTS
	IERR1=0
	IERR2=0
	IERR3=0
	IERR4=0
	IERR5=0
	IERR6=0
	DO IBNDS=1,NSPIN                          !!! over spin subbands
	TOSK(IBNDS)=0.D0
	DOSK(IBNDS)=0.D0
	TOSQ(IBNDS)=0.D0
	DOSQ(IBNDS)=0.D0
	TWGT(IBNDS)=0.D0
	DO IPNT=1,NPNT                            !!! over k-points
	DO IBNDC=1,NBNDC(1)
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	DO IC=1,6
	WTST(IC,IBANC)=0.D0
	ENDDO
	ENDDO
	DO ISGQ=1,NSGQ                            !!! over q-star
	IREC=1+IPNT+NPNT*(ISGQ-1)
	READ(40,REC=IREC)WGTQ(1),(((WEIGQ(IBANC,IBANC1,IC,1),IBANC=1,
     &  NBNDC(1)*NSPIN),IBANC1=1,NBNDC(1)*NSPIN),IC=1,6),
     &  ((WEIGK(IBANC,IC,1),IBANC=1,NBNDC(1)*NSPIN),IC=1,4)
	WTST(1,1)=WTST(1,1)+WGTQ(1)
	TWGT(IBNDS)=TWGT(IBNDS)+WGTQ(1)
	IF(KSYMPN(ISGQ,IPNT).LT.0)WTST(2,1)=WTST(2,1)+WGTQ(1)
	DO IBNDC=1,NBNDC(1)                       !!! over bands
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	WTST(3,IBANC)=WTST(3,IBANC)+WEIGK(IBANC,1,1)
	IF(KSYMPN(ISGQ,IPNT).LT.0)
     &  WTST(4,IBANC)=WTST(4,IBANC)+WEIGK(IBANC,1,1)
	WTST(5,IBANC)=WTST(5,IBANC)+WEIGK(IBANC,3,1)
	IF(KSYMPN(ISGQ,IPNT).LT.0)
     &  WTST(6,IBANC)=WTST(6,IBANC)+WEIGK(IBANC,3,1)
	TOSK(IBNDS)=TOSK(IBNDS)+WEIGK(IBANC,1,1)/DBLE(NSPIN)
	TOSQ(IBNDS)=TOSQ(IBNDS)+WEIGK(IBANC,2,1)/DBLE(NSPIN)
	DOSK(IBNDS)=DOSK(IBNDS)+WEIGK(IBANC,3,1)/DBLE(NSPIN)
	DOSQ(IBNDS)=DOSQ(IBNDS)+WEIGK(IBANC,4,1)/DBLE(NSPIN)
	ENDDO                                     !!! over bands
	ENDDO                                     !!! over q-star
	IF(ABS(WTST(1,1)-WGT(IPNT)).GE.1.D-07)IERR1=1
	IF(ABS(WTST(2,1)).GE.1.D-07)IERR2=1
	DO IBNDC=1,NBNDC(1)                       !!! over bands
	IBNDT=IBNDC+NBNDE(1)-1
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	IF(ABS(WTST(3,IBANC)-WEIGH(IBAND,IPNT)).GE.1.D-07)
     &  IERR3=1
	IF(ABS(WTST(4,IBANC)).GE.1.D-07)IERR4=1
	IF(ABS(WTST(5,IBANC)-WEIGD(IBAND,IPNT)).GE.1.D-07)
     &  IERR5=1
	IF(ABS(WTST(6,IBANC)).GE.1.D-07)IERR6=1
	ENDDO                                     !!! over bands
	ENDDO                                     !!! over k-points
	ENDDO                                     !!! over spin subbands
	IF(IERR1.NE.0)PRINT*,'<DELTET>: IERR1.NE.0'
	IF(IERR2.NE.0)PRINT*,'<DELTET>: IERR2.NE.0'
	IF(IERR3.NE.0)PRINT*,'<DELTET>: IERR3.NE.0'
	IF(IERR4.NE.0)PRINT*,'<DELTET>: IERR4.NE.0'
	IF(IERR5.NE.0)PRINT*,'<DELTET>: IERR5.NE.0'
	IF(IERR6.NE.0)PRINT*,'<DELTET>: IERR6.NE.0'
	IF(NSPIN.EQ.2.AND.NORBS.EQ.1)THEN
	DO IBNDS=1,NSPIN
	IF(IBNDS.EQ.1)
     &  WRITE(IUN,1010)TWGT(IBNDS),TOSK(IBNDS),DOSK(IBNDS)
	IF(IBNDS.EQ.1)
     &  WRITE(IUN,1020)TWGT(IBNDS),TOSQ(IBNDS),DOSQ(IBNDS)
	IF(IBNDS.EQ.2)
     &  WRITE(IUN,1030)TWGT(IBNDS),TOSK(IBNDS),DOSK(IBNDS)
	IF(IBNDS.EQ.2)
     &  WRITE(IUN,1040)TWGT(IBNDS),TOSQ(IBNDS),DOSQ(IBNDS)
	ENDDO
1010	FORMAT(1X,'UP-states: TEST,TOSK,DOSK==',3(1X,G14.7))
1020	FORMAT(1X,'UP-states: TEST,TOSQ,DOSQ==',3(1X,G14.7))
1030	FORMAT(1X,'DN-states: TEST,TOSK,DOSK==',3(1X,G14.7))
1040	FORMAT(1X,'DN-states: TEST,TOSQ,DOSQ==',3(1X,G14.7))
	ENDIF
        WRITE(IUN,1050)(TWGT(1)+TWGT(NSPIN))/2.D0*DBLE(NSPIN),
     &                 (TOSK(1)+TOSK(NSPIN))/2.D0*DBLE(NSPIN),
     &                 (DOSK(1)+DOSK(NSPIN))/2.D0*DBLE(NSPIN)
        WRITE(IUN,1060)(TWGT(1)+TWGT(NSPIN))/2.D0*DBLE(NSPIN),
     &                 (TOSQ(1)+TOSQ(NSPIN))/2.D0*DBLE(NSPIN),
     &                 (DOSQ(1)+DOSQ(NSPIN))/2.D0*DBLE(NSPIN)
1050	FORMAT(1X,'AL-states: TEST,TOSK,DOSK==',3(1X,G14.7))
1060	FORMAT(1X,'AL-states: TEST,TOSQ,DOSQ==',3(1X,G14.7))
C  TEST CHIQ
	DO IBNDS=1,NSPIN
	DO IBNDC=1,NBNDC(1)
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	DO IBNDS1=1,NSPIN
	DO IBNDC1=1,NBNDC(1)
	IBANC1=IBNDS1+NSPIN*(IBNDC1-1)
	DO IC=1,8
	CHIQ(IBANC,IBANC1,IC)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	DO ISGQ=1,NSGQ                            !!! over q-star
	DO IPNT=1,NPNT                            !!! over k-points
        IF(KSYMPN(ISGQ,IPNT).GE.0)THEN
C  SET POINT-GROUP INFORMATION
        IRK=ISG(1,ISGQ)
        IGK=IKOV(IRK)
        IPNTK=IPNT
        IRQ=IG0IG1(IPNT,IRK)
        IGQ=IKOV(IRQ)
        IPNTQ=IK0IK1(IPNT,IRK)
C  READ TETRAHEDRON WEIGHTS FOR BRILLOUIN ZONE INTEGRATION
	IREC=1+IPNT+NPNT*(ISGQ-1)
	READ(40,REC=IREC)WGTQ(1),(((WEIGQ(IBANC,IBANC1,IC,1),
     &  IBANC=1,NBNDC(1)*NSPIN),IBANC1=1,NBNDC(1)*NSPIN),IC=1,6),
     &  ((WEIGK(IBANC,IC,1),IBANC=1,NBNDC(1)*NSPIN),IC=1,4)
C  INTEGRATE OVER BZ
	DO IBNDS=1,NSPIN
	DO IBNDC=1,NBNDC(1)
	IBNDT=IBNDC+NBNDE(1)-1
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO IBNDS1=1,NSPIN
	DO IBNDC1=1,NBNDC(1)
	IBNDT1=IBNDC1+NBNDE(1)-1
	IBANC1=IBNDS1+NSPIN*(IBNDC1-1)
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
	DO IC=1,6
	CHIQ(IBANC,IBANC1,IC)=CHIQ(IBANC,IBANC1,IC)+
     &  WEIGQ(IBANC,IBANC1,IC,1)
	ENDDO
        DEK=EARR(IBAND,IPNTK,1)-EARR(IBAND1,IPNTQ,1)
	CHIQ(IBANC,IBANC1,7)=CHIQ(IBANC,IBANC1,7)+
     &  WEIGK(IBANC,1,1)*DEK/(DEK**2+POLUS**2)
	CHIQ(IBANC,IBANC1,8)=CHIQ(IBANC,IBANC1,8)+
     &  WEIGK(IBANC1,2,1)*DEK/(DEK**2+POLUS**2)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDIF
        ENDDO                               !!! over irreducible points
        ENDDO                               !!! over star of the q-vector
C  PRINT TEST DATA
	DO IBNDS=1,NSPIN                    !!! over spin subbands
	DO IBNDS1=1,NSPIN                   !!! over spin subbands
	IF(IBNDS.EQ.1.AND.IBNDS1.EQ.1)WRITE(IUN,1111)
	IF(IBNDS.EQ.2.AND.IBNDS1.EQ.1)WRITE(IUN,1112)
	IF(IBNDS.EQ.1.AND.IBNDS1.EQ.2)WRITE(IUN,1113)
	IF(IBNDS.EQ.2.AND.IBNDS1.EQ.2)WRITE(IUN,1114)
	WRITE(IUN,1115)
	CHIT=0.D0
	CHID=0.D0
	CHIF=0.D0
	CHIW=0.D0
	DO IBNDC=1,NBNDC(1)
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	DO IBNDC1=1,NBNDC(1)
	IBANC1=IBNDS1+NSPIN*(IBNDC1-1)
	CHIT=CHIT+CHIQ(IBANC,IBANC1,1)-CHIQ(IBANC,IBANC1,2)
	CHID=CHID+CHIQ(IBANC,IBANC1,3)-CHIQ(IBANC,IBANC1,4)
	CHIF=CHIF+CHIQ(IBANC,IBANC1,5)-CHIQ(IBANC,IBANC1,6)
	CHIW=CHIW+CHIQ(IBANC,IBANC1,7)-CHIQ(IBANC,IBANC1,8)
	WRITE(IUN,1120)IBNDC,IBNDC1,
     &  CHIQ(IBANC,IBANC1,1)-CHIQ(IBANC,IBANC1,2),
     &	CHIQ(IBANC,IBANC1,3)-CHIQ(IBANC,IBANC1,4),
     &	CHIQ(IBANC,IBANC1,5)-CHIQ(IBANC,IBANC1,6),
     &	CHIQ(IBANC,IBANC1,7)-CHIQ(IBANC,IBANC1,8)
	ENDDO
	ENDDO
	WRITE(IUN,1130)
	WRITE(IUN,1140)CHIT,CHID,CHIT+CHID
	WRITE(IUN,1150)CHIF,CHIW,CHIF-CHIW
        ENDDO                               !!! over spin subbands
        ENDDO                               !!! over spin subbands
1111	FORMAT(1X,'Susceptibility calculation, states UP-UP:')
1112	FORMAT(1X,'Susceptibility calculation, states UP-DN:')
1113	FORMAT(1X,'Susceptibility calculation, states DN-UP:')
1114	FORMAT(1X,'Susceptibility calculation, states DN-DN:')
1115	FORMAT(1X,'ibnd  ibnd1',4X,'chi(V)',9X,'chi(F)',
     &  9X,'chi1(d)',8X,'chi2(d)')
1120	FORMAT(1X,1X,I2,4X,I2,4(1X,G14.7))
1130	FORMAT(1X,'Sum over band index and TOS,DOS numbers ::')
1140	FORMAT(1X,'CHIT,CHID,CHIS==',3(1X,G14.7))
1150	FORMAT(1X,'CHIF,CHIW,DIFF==',3(1X,G14.7))
C TEST IMAGINARY PART
        CHIM(1)=0.D0
        CHIM(2)=0.D0
        CHI0(1)=0.D0
        CHI0(2)=0.D0
        DO ISGQ=1,NSGQ                            !!! over star of the q-vector
        DO IPNT=1,NPNT                            !!! over irreducible points
        IREC=1+IPNT+NPNT*(ISGQ-1)
        READ(40,REC=IREC)WGTQ(1),(((WEIGQ(IBANC,IBANC1,IC,1),
     &  IBANC=1,NBNDC(1)*NSPIN),IBANC1=1,NBNDC(1)*NSPIN),
     &  IC=1,6),((WEIGK(IBANC,IC,1),IBANC=1,NBNDC(1)*NSPIN),
     &  IC=1,4),(((WGTOM(IBANC,IBANC1,IC,1),IBANC=1,
     &  NBNDC(1)*NSPIN),IBANC1=1,NBNDC(1)*NSPIN),IC=1,4)
        DO IBNDS1=1,NSPIN
        DO IBNDC1=1,NBNDC(1)
        IBANC1=IBNDS1+NSPIN*(IBNDC1-1)
        DO IBNDS=1,NSPIN
        DO IBNDC=1,NBNDC(1)
        IBANC=IBNDS+NSPIN*(IBNDC-1)
        CHIM(1)=CHIM(1)+
     &  WGTOM(IBANC,IBANC1,1,1)
        CHIM(2)=CHIM(2)+
     &  WGTOM(IBANC,IBANC1,2,1)
        CHI0(1)=CHI0(1)+
     &  WGTOM(IBANC,IBANC1,3,1)
        CHI0(2)=CHI0(2)+
     &  WGTOM(IBANC,IBANC1,4,1)
        ENDDO
        ENDDO
        ENDDO
        ENDDO
        ENDDO                                     !!! over irreducible points
        ENDDO                                     !!! over star of the q-vector
        WRITE(IUN,1210)
        WRITE(IUN,1220)OMGR*13.6058D0*1000.D0
	WRITE(IUN,1230)CHIM(1)
	WRITE(IUN,1240)CHI0(1)*OMGR
	WRITE(IUN,1250)CHI0(1)
1210    FORMAT(1X,'Imaginary susceptibility Im[chi(q,w)] -->')
1220	FORMAT(1X,'Frequency       = ',G14.7,' meV')
1230	FORMAT(1X,'Im[chi(q,w)]    = ',G14.7)
1240	FORMAT(1X,'Im[chi(q,w)]/w*w= ',G14.7)
1250	FORMAT(1X,'Im[chi(q,w)]/w  = ',G14.7)
        WRITE(IUN,1310)
        WRITE(IUN,1320)OMGR*13.6058D0*1000.D0
	WRITE(IUN,1330)CHIM(2)
	WRITE(IUN,1340)CHI0(2)*OMGR
	WRITE(IUN,1350)CHI0(2)
1310    FORMAT(1X,'Transport susceptibility Im[chi(q,w)]<v2> ')
1320	FORMAT(1X,'Frequency       = ',G14.7,' meV')
1330	FORMAT(1X,'Tr[chi(q,w)]    = ',G14.7)
1340	FORMAT(1X,'Tr[chi(q,w)]/w*w= ',G14.7)
1350	FORMAT(1X,'Tr[chi(q,w)]/w  = ',G14.7)
	END
