	SUBROUTINE SSCRPOT(IQPNT,ITER)
************************************************************
*   The calculation of the screened long-range part of the *
*   potential and corresponding contribution to deltarho.  *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &    ,ILSV(NSORTMAX),NITER(0:NENVMAX,-1:2)
	DIMENSION QPNT(3)
	LOGICAL EXIST
	CHARACTER TXTEL(NSORTMAX)*10
        COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE         !!! from init
        COMMON /MAGCOM/ ITERMAX,NITER                        !!! from init
        COMMON /PLZCOM/ NPLZ,LPLZ,IPLZ                       !!! from init
        COMMON /PTBCOM/ NGSHL,NGPTB                          !!! from plwptb
        COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM        !!! from init
	COMMON /QMESH/  NQPNT,QPNT                           !!! from init
        COMMON /SPIN/   NSPIN                                !!! from init
        COMMON /TXTEL/  TXTEL                                !!! from init
	COMMON /UNIT/   IUN                                  !!! from init
	IF(MODE.EQ.5)RETURN
	CALL READSCF                           !!! reads charge density
C  DO GLOBALLY OVER DISPLACEMENTS AND POLARIZATIONS
	DO 2000 MY=-1,2                        !!! over polarizations
	DO 1000 IGPTB=0,NGPTB                  !!! over g-vectors
        IF(NITER(IGPTB,MY).EQ.0)GOTO1000
C  READ CHANGE IN CHARGE DENSITY DUE TO SHORT-RANGE PART OF THE POTENTIAL
	IF(NPLZ.EQ.1)
     &  CALL DROFILES(IGPTB,MY,IQPNT,33,'R')   !!! read change in density within MTS
	IF(NPLZ.EQ.0)
     &  CALL DROFILES(IGPTB,MY,IQPNT,32,'R')   !!! screening is OFF, old scheme
        IF(LPLZ.EQ.0)GOTO500
C  CALCULATE SCREENED "SOFT" PART OF THE RESPONSE
   	CALL DMULTRHO(IGPTB,MY,IQPNT)          !!! change in pseudodensity moments
        CALL PRINT4(IGPTB,MY,IQPNT,1)          !!! get screened charge transfer
C  ADD LONG-RANGE CONTRIBUTION TO THE INDUCED DENSITY
        CALL DROFILES(IGPTB,MY,IQPNT,33,'R')   !!! read change in density
	DO ISPIN=1,NSPIN
        CALL DROFILES(IGPTB,MY,IQPNT,33,'W')   !!! store change in density
        ENDDO   
C  PRINT INPUT/OUTPUT INDUCED CHARGE TRANSFER
 500	CALL DMULTRHO(IGPTB,MY,IQPNT)          !!! change in pseudodensity moments
        CALL PRINT4(IGPTB,MY,IQPNT,2)          !!! printing routine
1000	CONTINUE                               !!! over g-vectors
2000	CONTINUE                               !!! over polarizations
	END
